jQuery(document).ready( function ( e ) {
	// Hide the advanced settings on first load, toggled via the ".advanced-settings" button.
	jQuery( '#laboratory_slideshow-advanced-settings' ).hide();
	jQuery( 'a.advanced-settings' ).click( function ( e ) {
		jQuery( '#laboratory_slideshow-advanced-settings' ).toggle();
	});

	// Hide the conditional boxes on first load, and show only the relevant section.
	var currentType = jQuery( 'select#slidetype' ).val();
	if ( typeof( currentType ) != 'undefined' ) {
		jQuery( '.conditional:not(".conditional-' + currentType + '")' ).hide();
		jQuery( '.conditional-' + currentType + '' ).show();
	}

	jQuery( 'select#slidetype' ).change( function ( e ) {
		var currentType = jQuery( 'select#slidetype' ).val();
		if ( typeof( currentType ) != 'undefined' ) {
			jQuery( '.conditional:not(".conditional-' + currentType + '")' ).hide();
			jQuery( '.conditional-' + currentType + '' ).show();
		}
	});


	// Shortcode creator logic.
	jQuery( 'form#laboratory_slideshow-insert' ).submit( function ( e ) {
	var shortcode_atts = '';

	for ( var prop in laboratory_slideshow_settings ) {
		if ( laboratory_slideshow_settings.hasOwnProperty( prop ) ) {
			var defaultValue = laboratory_slideshow_settings[prop];
			var element = jQuery( this ).find( '#' + prop + ':visible, #' + prop + '.range-input' );
			// Ignore the form fields if they're in a conditional box and that box is hidden.
			if ( element.parents( '.conditional' ).length == 1 && element.parents( '.conditional' ).is( ':hidden' ) ) { continue; }

			if ( element ) {
				// Checkboxes.
				if ( element.is( 'input' ) && element.attr( 'type' ) == 'checkbox' ) {
					if ( element.attr( 'checked' ) && defaultValue != 1 ) {
						shortcode_atts += ' ' + prop + '="true"';
					}
					if ( element.attr( 'checked' ) != 'checked' && defaultValue != 0 ) {
						shortcode_atts += ' ' + prop + '="false"';
					}
				}

				// Select fields.
				if ( element.is( 'select' ) && element.val() != defaultValue ) {
					shortcode_atts += ' ' + prop + '="' + element.val() + '"';
				}

				// Radio buttons.
				if ( element.is( 'input' ) && element.attr( 'type' ) == 'radio' ) {
					shortcode_atts += ' ' + prop + '="' + element.val() + '"';
				}

				// Text input fields.
				if ( element.is( 'input' ) && ( element.attr( 'type' ) == 'text' ) && element.val() != defaultValue ) {
					shortcode_atts += ' ' + prop + '="' + element.val() + '"';
				}
			}
		}

		// Cater for multicheck fields and individual checkbox fields.
		if ( laboratory_slideshow_settings.hasOwnProperty( prop ) ) {
			var defaultValue = laboratory_slideshow_settings[prop];
			var element = jQuery( this ).find( 'input.multicheck.multicheck-' + prop + ':checked' );
			// Ignore the form fields if they're in a conditional box and that box is hidden.
			if ( element.parents( '.conditional' ).length == 1 && element.parents( '.conditional' ).is( ':hidden' ) ) { continue; }
			
			var options_string = '';
			if ( element.length && element.is( 'input[type="checkbox"]' ) && element.hasClass( 'multicheck' ) ) {
				element.each( function ( i, e ) {
					if ( i > 0 ) { options_string += ','; }
					options_string += jQuery( this ).val();
				});
			}

			if ( options_string != '' ) {
				shortcode_atts += ' ' + prop + '="' + options_string + '"';
			}
		}

		// Cater for radio inputs.
		if ( laboratory_slideshow_settings.hasOwnProperty( prop ) ) {
			var defaultValue = laboratory_slideshow_settings[prop];
			var element = jQuery( this ).find( 'input[type="radio"][name="' + prop + '"]:checked' );
			// Ignore the form fields if they're in a conditional box and that box is hidden.
			if ( element.parents( '.conditional' ).length == 1 && element.parents( '.conditional' ).is( ':hidden' ) ) { continue; }
			
			if ( element.length && element.is( 'input[type="radio"]' ) ) {
				shortcode_atts += ' ' + prop + '="' + element.val() + '"';
			}
		}
	}

	var shortcode = '[laboratory_slideshow' + shortcode_atts + '] ';
	var win = window.dialogArguments || opener || parent || top;
	win.send_to_editor( shortcode );
	return false;
});
});